from charmhelpers.core import hookenv
from charmhelpers.contrib.charmsupport.nrpe import NRPE
import hashlib
from urlparse import urlparse
# import thruk_helpers
import subprocess
import base64


def log_start(service_name):
    hookenv.log('thruk-external-agent starting')


def notify_thrukmaster_relation(service_name):
    # rel_data = thruk_helpers.ThrukAgentRelation()
    thruk_data = {}

    # for unit in rel_data[rel_data.name]:
    thruk_data['url'] = hookenv.config('url')
    thruk_data['nagios_context'] = hookenv.config('nagios_context')
    thruk_data['thruk_key'] = hookenv.config('thruk_key')
    m = hashlib.md5()
    m.update(hookenv.config('nagios_context'))
    thruk_data['thruk_id'] = m.hexdigest()

    for rel_id in hookenv.relation_ids('thruk-agent'):
        hookenv.relation_set(relation_id=rel_id, relation_settings=thruk_data)


def update_nrpe_config(service_name):
    nrpe_compat = NRPE()
    # or should it be nrpe_compat = NRPE(primary=False)
    parsed_url = urlparse(hookenv.config('url'))
    thruk_query = ('data={\\"options\\":{\\"action\\":\\"raw\\",\\"remote_name\\":'
                   '\\"\\",\\"args\\":null,\\"sub\\":\\"get_processinfo\\"},'
                   '\\"credential\\":\\"' + hookenv.config('thruk_key') + '\\"}')
    if parsed_url.path.endswith('/'):
        thruk_url = parsed_url.path + 'thruk/cgi-bin/remote.cgi'
    else:
        thruk_url = parsed_url.path + '/thruk/cgi-bin/remote.cgi'
    check_cmd = " ".join([
            "/usr/lib/nagios/plugins/check_http",
            "-w 5",
            "-c 15",
            "-H {}".format(parsed_url.hostname),
            "-k \\'Accept: */*\\'",
            "-u {}".format(thruk_url),
            '-s nagios_pid',
            "-P \\'{}\\'".format(thruk_query),
            ])
    if parsed_url.scheme == 'https':
        check_cmd += " -S"
    shortname = "{}-{}".format(hookenv.config('nagios_context'),
                               hookenv.local_unit().replace('/', '-'))
    nrpe_compat.add_check(
        shortname=shortname,
        description="Check Nagios PID via thruk agent",
        check_cmd=check_cmd,
        )
    nrpe_compat.write()


def thruk_fix_ssl(service_name):

    if hookenv.config('trusted_ssl_cert'):
        cert_file = None
        if hookenv.config('trusted_ssl_certlocation'):
            cert_file = '/usr/local/share/ca-certificates/%s' % \
                (hookenv.config('trusted_ssl_certlocation').rpartition('/')[2])

        trusted_ssl_cert = hookenv.config('trusted_ssl_cert')
        hookenv.log("Writing cert from trusted_ssl_cert: %s"
                    % trusted_ssl_cert)
        with open(cert_file, 'w') as f:
            f.write(str(base64.b64decode(trusted_ssl_cert)))

        subprocess.call(["/usr/sbin/update-ca-certificates"])
