#!/usr/bin/python

from charmhelpers.core import hookenv
from charmhelpers.core.services import helpers

import hashlib


class ThrukAgentRelation(helpers.RelationContext):
    """
    Relation context for the `thruk-agent` interface.

    :param str name: Override the relation :attr:`name`, since it can vary from charm to charm
    :param list additional_required_keys: Extend the list of :attr:`required_keys`
    """
    name = 'thruk-agent'
    interface = 'thruk-agent'

    def provide_data(self):
        m = hashlib.md5()
        m.update(hookenv.config('nagios_context'))
        thruk_id = m.hexdigest()

        return {
            'url': hookenv.config('url'),
            'nagios_context': hookenv.config('nagios_context'),
            'thruk_key': hookenv.config('thruk_key'),
            'thruk_id': thruk_id,
        }
